
// game.h

unsigned char buffercete [800];		// Para el efecto de la cortina, jo... ie.
unsigned char buffer_nanako [12];	// Para el fondo de nanako.

// Borrar todo el tablero.

void clear_tablero () {
	unsigned char i;
	
	for (i = 0; i < 35; i ++) {
		tablero [i].c1 = 0;
		tablero [i].c2 = 0;
	}	
}

// Rellenar una linea del tablero

void fill_line (unsigned char linea, unsigned char max_colores) {
	unsigned char i;
	unsigned char base = linea * 5;
	
	for (i = 0; i < 5; i ++) {
		tablero [base + i].c1 = 1 + rand () % max_colores;
		do {
			tablero [base + i].c2 = 1 + rand () % max_colores;
		} while (tablero [base + i].c2 == tablero [base + i].c1); 
	}
		
	i = rand () % 5;
	
	tablero [base + i].c1 = 0;
	tablero [base + i].c2 = 0;
}

// Inicializar el tablero

void init_tablero (unsigned char max_colores) {
	unsigned char i;
	
	clear_tablero ();
	for (i = 0; i < 6; i ++)
		fill_line (i, max_colores);
}

// Scrollea el tablero (baja todo e introduce una nueva linea)

void scroll_tablero (unsigned char max_colores) {
	unsigned char i;
	
	for (i = 34; i >= 5; i --) {
		tablero [i].c1 = tablero [i - 5].c1;
		tablero [i].c2 = tablero [i - 5].c2;
	}	
	
	fill_line (0, max_colores);
}

// Controla si nanako puede moverse a una casilla 

unsigned char puede_mover (unsigned char dx, unsigned char dy) {
	return (nanako.p == tablero [dx + 5 * dy].c1 || nanako.p == tablero [dx + 5 * dy].c2 || tablero [dx + 5 * dy].c1 == 0);
}

// Rutina de movimiento de Nanako por el tablero

void mueve () {
	unsigned char i, x, y;	
	unsigned char moved;
	FICHA ficha;
	
	// Primero vemos si nos podemos mover ...
	
	moved = 0;
	
	i = (joyfunc) (&keys);
	
	if ((i & sp_LEFT) == 0 && nanako.x > 0) {
		if (puede_mover (nanako.x - 1, nanako.y))
			nanako.x --;
			
		while ((i & sp_LEFT) == 0) {
			i = (joyfunc) (&keys);
		}
		
		moved = 1;
	}
			
	if ((i & sp_RIGHT) == 0 && nanako.x < 4) {
		if (puede_mover (nanako.x + 1, nanako.y))
			nanako.x ++;
			
		while ((i & sp_RIGHT) == 0) {
			i = (joyfunc) (&keys);
		}
		
		moved = 1;
	}
	
	if ((i & sp_UP) == 0 && nanako.y > 0) {
		if (puede_mover (nanako.x, nanako.y - 1))
			nanako.y --;
			
		while ((i & sp_UP) == 0) {
			i = (joyfunc) (&keys);
		}
		
		moved = 1;
	}
	
	if ((i & sp_DOWN) == 0 && nanako.y < 6) {
		if (puede_mover (nanako.x, nanako.y + 1))
			nanako.y ++;
			
		while ((i & sp_DOWN) == 0) {
			i = (joyfunc) (&keys);
		}
		
		moved = 1;
	}
	
	// Y si nos hemos movido, vemos qu pasa
	
	if (moved) {
		// Contamos un movimiento ms
		
		nanako.ct ++;
		
		// Vemos qu haba en el tablero.
		
		ficha.c1 = tablero [nanako.x + 5 * nanako.y].c1;
		ficha.c2 = tablero [nanako.x + 5 * nanako.y].c2;
		
		// Si la ficha que lleva nanako coincide con uno de los
		// dos colores de la casilla, la intercambiamos por el otro.
		
		if (ficha.c1 == nanako.p) {
			nanako.p = ficha.c2;
			nanako.n_fichas ++;
		} else if (ficha.c2 == nanako.p) {
			nanako.p = ficha.c1;
			nanako.n_fichas ++;
		}
		
		// Borramos la casilla
		
		tablero [nanako.x + 5 * nanako.y].c1 = 0;
		tablero [nanako.x + 5 * nanako.y].c2 = 0;
		
		x = TABLERO_X + (nanako.x << 2);
		y = TABLERO_Y + (nanako.y << 1) + nanako.y;
	
		sp_PrintAtInv (y    , x    , 71, 72);
		sp_PrintAtInv (y    , x + 1, 71, 74);
		sp_PrintAtInv (y    , x + 2, 71, 81);
		
		sp_PrintAtInv (y + 1, x    ,  7, 73);
		sp_PrintAtInv (y + 1, x + 1,  7, 75);
		sp_PrintAtInv (y + 1, x + 2,  7, 82);
		
		// Si no coincide ningn color es que la casilla estaba vaca.
	}
}

// Pinta el tablero en la pantalla a partir de su posicin
// definida en TABLERO_X y TABLERO_Y

void draw_tablero () {
	unsigned char x, y;
	unsigned char auxx, auxy;		// Para precalcular.
	unsigned char i;
	
	// Espacios entre los bloques
	
	for (y = 0; y < 7; y ++) {
		auxy = TABLERO_Y + y + y + y;
		for (x = 0; x < 5; x ++) {
			auxx = TABLERO_X + x + x + x + x;
			sp_PrintAtInv (auxy + 2, auxx    ,  7,  0);
			sp_PrintAtInv (auxy + 2, auxx + 1, 71, 76);
			sp_PrintAtInv (auxy + 2, auxx + 2,  7,  0);
			if (x != 4) {
				sp_PrintAtInv (auxy    , auxx + 3, 71, 70);
				sp_PrintAtInv (auxy + 1, auxx + 3,  7, 71);
				sp_PrintAtInv (auxy + 2, auxx + 3,  7,  0);
			}
		}
	}
		
	// Bloques
	
	x = TABLERO_X;
	y = TABLERO_Y;
	
	for (i = 0; i < 35; i ++) {
		if (tablero [i].c1 == 0) {
			// espacio vaco
			
			sp_PrintAtInv (y    , x    , 71, 72);
			sp_PrintAtInv (y    , x + 1, 71, 74);
			sp_PrintAtInv (y    , x + 2, 71, 81);
			
			sp_PrintAtInv (y + 1, x    ,  7, 73);
			sp_PrintAtInv (y + 1, x + 1,  7, 75);
			sp_PrintAtInv (y + 1, x + 2,  7, 82);
		} else {
			// fisha
			
			sp_PrintAtInv (y    , x    , 64 + tablero [i].c1, 64);
			sp_PrintAtInv (y    , x + 1, 69, 68);
			sp_PrintAtInv (y    , x + 2, 64 + tablero [i].c2, 66);
			
			sp_PrintAtInv (y + 1, x    , tablero [i].c1, 65);
			sp_PrintAtInv (y + 1, x + 1, 5, 69);
			sp_PrintAtInv (y + 1, x + 2, tablero [i].c2, 67);
		}
		
		x += 4;
		if (x == TABLERO_X + 20) {
			x = TABLERO_X;
			y += 3;
		}
	}
}

// Pinta el tablero en el buffercete y luego lo muestra poquino 
// a poquino.

void PrintAtBuffercete (unsigned char y, unsigned char x, unsigned char atr, unsigned char chr) {
	// y * 19 = y * 16 + y * 2 + y = (y << 4) + (y << 1) + y
	int aux;
	
	aux = ((y << 4) + (y << 1) + y + x) << 1;
	buffercete [aux] = atr;
	buffercete [aux + 1] = chr;
}

void unveil_tablero () {
	unsigned char x, y;
	unsigned char auxx, auxy;		// Para precalcular.
	unsigned char i;
	int aux; 
	
	// Espacios entre los bloques
	
	for (y = 0; y < 7; y ++) {
		auxy = y + y + y;
		for (x = 0; x < 5; x ++) {
			auxx = x + x + x + x;
			PrintAtBuffercete (auxy + 2, auxx    ,  7,  0);
			PrintAtBuffercete (auxy + 2, auxx + 1, 71, 76);
			PrintAtBuffercete (auxy + 2, auxx + 2,  7,  0);
			if (x != 4) {
				PrintAtBuffercete (auxy    , auxx + 3, 71, 70);
				PrintAtBuffercete (auxy + 1, auxx + 3,  7, 71);
				PrintAtBuffercete (auxy + 2, auxx + 3,  7,  0);
			}
		}
	}
		
	// Bloques
	
	x = 0;
	y = 0;
	
	for (i = 0; i < 35; i ++) {
		if (tablero [i].c1 == 0) {
			// espacio vaco
			
			PrintAtBuffercete (y    , x    , 71, 72);
			PrintAtBuffercete (y    , x + 1, 71, 74);
			PrintAtBuffercete (y    , x + 2, 71, 81);
			
			PrintAtBuffercete (y + 1, x    ,  7, 73);
			PrintAtBuffercete (y + 1, x + 1,  7, 75);
			PrintAtBuffercete (y + 1, x + 2,  7, 82);
		} else {
			// fisha
			
			PrintAtBuffercete (y    , x    , 64 + tablero [i].c1, 64);
			PrintAtBuffercete (y    , x + 1, 69, 68);
			PrintAtBuffercete (y    , x + 2, 64 + tablero [i].c2, 66);
			
			PrintAtBuffercete (y + 1, x    , tablero [i].c1, 65);
			PrintAtBuffercete (y + 1, x + 1, 5, 69);
			PrintAtBuffercete (y + 1, x + 2, tablero [i].c2, 67);
		}
		
		x += 4;
		if (x == 20) {
			x = 0;
			y += 3;
		}
	}
	
	// Ahora la animacin
	
	for (y = 0; y < 21; y ++) {
		for (x = 0; x < 19; x ++) 
			sp_PrintAtInv (TABLERO_Y + y, TABLERO_X + x, ((y & 1) << 6) + 6, 89);
	}
	
	for (y = 0; y < 21; y ++) {
		for (x = 0; x < 19; x ++) {
			auxy = 20 - y;
			aux = ((auxy << 4) + (auxy << 1) + auxy + x) << 1;
			sp_PrintAtInv (TABLERO_Y + auxy, TABLERO_X + x, buffercete [aux], buffercete [aux + 1]);
		}
		
		sp_UpdateNow ();
		#asm
			halt
			halt
		#endasm	
	}
	
	x = TABLERO_X + (nanako.x << 2);
	y = TABLERO_Y + (nanako.y << 1) + nanako.y;
	
	for (i = 0; i < 7; i ++) {	
		sp_PrintAtInv (y    , x    , 64 + i, 77);
		sp_PrintAtInv (y    , x + 1, 64 + i, 78);
		sp_PrintAtInv (y    , x + 2, 64 + nanako.p, 66);
		
		sp_PrintAtInv (y + 1, x    , i, 79);
		sp_PrintAtInv (y + 1, x + 1, i, 80);
		sp_PrintAtInv (y + 1, x + 2, nanako.p, 67);
		
		sp_UpdateNow ();
		#asm
			halt
			halt
		#endasm	
	}
}

void get_fondo_nanako () {
	rectangulo.col_coord = TABLERO_X + (nanako.x << 2) + nanako.xstp;
	rectangulo.row_coord = TABLERO_Y + (nanako.y << 1) + nanako.y + nanako.ystp;
	
	sp_GetTiles (&rectangulo, buffer_nanako);
}

void borra_nanako () {
	rectangulo.col_coord = TABLERO_X + (nanako.x << 2) + nanako.xstp;
	rectangulo.row_coord = TABLERO_Y + (nanako.y << 1) + nanako.y + nanako.ystp;
	
	sp_PutTiles (&rectangulo, buffer_nanako);
	sp_Invalidate (&rectangulo, &rectangulo);
}

void pinta_nanako () {
	unsigned char x = TABLERO_X + (nanako.x << 2) + nanako.xstp;
	unsigned char y = TABLERO_Y + (nanako.y << 1) + nanako.y + nanako.ystp;
	
	sp_PrintAtInv (y    , x    , 71, 77);
	sp_PrintAtInv (y    , x + 1, 71, 78);
	sp_PrintAtInv (y    , x + 2, 64 + nanako.p, 66);
	
	sp_PrintAtInv (y + 1, x    , 69, 79);
	sp_PrintAtInv (y + 1, x + 1, 69, 80);
	sp_PrintAtInv (y + 1, x + 2, nanako.p, 67);
}

void pinta_ouch () {
	unsigned char x = TABLERO_X + (nanako.x << 2);
	unsigned char y = TABLERO_Y + (nanako.y << 1) + nanako.y;
	
	sp_PrintAtInv (y    , x    , 71, 83);
	sp_PrintAtInv (y    , x + 1, 71, 84);
	sp_PrintAtInv (y    , x + 2, 71, 85);
	
	sp_PrintAtInv (y + 1, x    ,  7, 86);
	sp_PrintAtInv (y + 1, x + 1,  7, 87);
	sp_PrintAtInv (y + 1, x + 2,  7, 88);	
}

void close_tablero () {
	unsigned char x, y;
	
	for (y = 0; y < 21; y ++) {
		for (x = 0; x < 19; x ++) 
			sp_PrintAtInv (TABLERO_Y + y, TABLERO_X + x, ((y & 1) << 6) + 6, 89);
		
		sp_UpdateNow ();
		#asm
			halt
			halt
		#endasm	
	}
}

unsigned char do_game (unsigned char max_colores, unsigned char num_piezas, unsigned char max_counter) {
	
	unsigned char resultado = 0;
	unsigned char terminado = 0;
	
	// max_colores			Nmero mximo de colores de piezas (2 a 7)
	// num_piezas			Piezas que hay que conseguir para ganar.
	// max_counter			Nmero de movimientos permitidos antes de escrollear.
	
	// Esta funcin devuelve:
	// 0 = BREAK
	// 1 = OK (el jugador consigui num_piezas)
	// 2 = GAME OVER (el jugador agot sus intentos)
	
	rectangulo.height = 2;
	rectangulo.width = 3;
	
	nanako.mct = max_counter;
	nanako.ct = 0;
	nanako.n_fichas = 0;
	nanako.p = 1 + rand () % max_colores;
	nanako.prendas = 3;
	
	// Posicin inicial: centrado abajo del todo
	
	nanako.x = 2;
	nanako.y = 6;
	nanako.xstp = 0;
	nanako.ystp = 0;
	nanako.estado = STATE_IDLE;
	
	// Inicializar y pintar el tablero
	
	init_tablero (max_colores);
	draw_tablero ();
	get_fondo_nanako ();
	
	// A escena!
	
	unveil_tablero ();
	
	// Y a dar vueltas...
	
	while (!terminado) {

		// Borramos a nanako
		
		borra_nanako ();
		
		// Movemos
		
		mueve ();
		
		// Pintamos a nanako
		
		get_fondo_nanako ();
		pinta_nanako ();
		
		// Render
		
		sp_UpdateNow ();	
		
		// Comprobaciones: Scroll
		
		if (nanako.ct == max_counter) {
			nanako.ct = 0;
			scroll_tablero (max_colores);
			if (nanako.y < 6)
				nanako.y ++;
			
			draw_tablero ();
		}
		
		// Comprobaciones: Nanako estrujada por un bloque tras un scroll
		
		if (tablero [nanako.x + 5 * nanako.y].c1 != 0) {
			
			// Hay que ver si el estrujamiento es legal o no!
			
			if (nanako.p == tablero [nanako.x + 5 * nanako.y].c1) {
				nanako.p = tablero [nanako.x + 5 * nanako.y].c2;
				tablero [nanako.x + 5 * nanako.y].c1 = 0;
				tablero [nanako.x + 5 * nanako.y].c2 = 0;
				nanako.n_fichas ++;
			} else if (nanako.p == tablero [nanako.x + 5 * nanako.y].c2) {
				nanako.p = tablero [nanako.x + 5 * nanako.y].c1;
				tablero [nanako.x + 5 * nanako.y].c1 = 0;
				tablero [nanako.x + 5 * nanako.y].c2 = 0;
				nanako.n_fichas ++;
			} else {			
				pinta_ouch ();
				sp_UpdateNow ();
				halt_me (120);
				
				nanako.prendas --;
				
				// Posicin inicial: centrado abajo del todo
				
				nanako.x = 2;
				nanako.y = 6;
				
				// Inicializar y pintar el tablero
				
				close_tablero ();
				init_tablero (max_colores);
				unveil_tablero ();
			}
		}
		
		// Comprobaciones: N de piezas
		
		// Comprobaciones: N de vidas
	}
}
